      SUBROUTINE PDGEEV1( N, A, IA, JA, DESCA, WR, WI,
     $                    WORK, LWORK, INFO )
*
      include 'mpif.h'
* Scalar Arguments
      INTEGER            IA, INFO, JA, LWORK, N
*
* Array Arguments
      INTEGER            DESCA( 9 )
      DOUBLE PRECISION   A( * ), WR( * ), WI( * ), WORK( * )
*
* Parameters
      INTEGER            DLEN_, DTYPE_, CTXT_, N_, MB_,
     $                   NB_, RSRC_, CSRC_, LLD_, ILWORK, NOUT
*
      PARAMETER          ( DLEN_ = 9, DTYPE_ = 1, MB_ = 5,
     $                   CTXT_ = 2, N_ = 4, NB_ = 6, LLD_ = 9 )
      DOUBLE PRECISION   ONE, ZERO, MONE
      PARAMETER          ( NOUT = 6, ZERO = 0.0D+0, ONE = 1.0D+0,
     $                     MONE = -1.0D+0, ILWORK = 1 )
*
* Local Scalars
      INTEGER            CTXT, I, IAM, ILO,IHI, ILOZ,IHIZ, IOFF, ILCOL,
     $                   IIA, JJA, JJ, IAROW, IACOL, IROFFA, ICOFFA,
     $                   IAFIST, JAFIRST, IHIP, IHLP, ILROW, INLQ, HBL,
     $                   LCMRC, LDA, LOCALK, LQUERY, LWORK1,
     $                   MYCOL, MYROW, NB, NPCOL, NPROW
*
* Local Arrays
      DOUBLE PRECISION   TAU( N ), Z( 1 ), WORK1( DESCA(NB_ ))
      INTEGER            IWORK( ILWORK )
*
* External Functions
      INTEGER            INDXG2P, NUMROC, ILCM
      EXTERNAL           LSAME, INDXG2P, NUMROC, ILCM
*
* External Subroutines
      EXTERNAL           BLACS_GRIDINFO, CHK1MAT, INFOG2L,
     $                   PCHK1MAT, PDLAPRNT, PXERBLA, PDGEHRD, PDLAHQR
*
* Intrinsic Functions
      INTRINSIC          ABS, DBLE, MAX, MIN, MOD, INT
*
* Executable Statements


      IA = 1
      JA = 1
      ILO = 1
      IHI = N
      ILOZ = 1
      IHIZ = N
*
      CTXT = DESCA(CTXT_)
      CALL BLACS_GRIDINFO( CTXT, NPROW, NPCOL, MYROW, MYCOL )
*
*     Test the input parameters
*
      INFO = 0
      IF( NPROW.EQ.-1 ) THEN
         INFO = -(500+CTXT_)
      ELSE
         CALL CHK1MAT( N, 1, N, 1, IA, JA, DESCA, 5, INFO )
         IF( INFO.EQ.0 ) THEN
            NB = DESCA( NB_ )
            IROFFA = MOD( IA-1, NB )
            ICOFFA = MOD( JA-1, NB )
            CALL INFOG2L( IA, JA, DESCA, NPROW, NPCOL, MYROW, MYCOL,
     $                    IIA, JJA, IAROW, IACOL )
            IHIP = NUMROC( IHI+IROFFA, NB, MYROW, IAROW, NPROW )
            IOFF = MOD( IA+ILO-2, NB )
            ILROW = INDXG2P( IA+ILO-1, NB, MYROW, DESCA( RSRC_ ),
     $                       NPROW )
            IHLP = NUMROC( IHI-ILO+IOFF+1, NB, MYROW, ILROW, NPROW )
            ILCOL = INDXG2P( JA+ILO-1, NB, MYCOL, DESCA( CSRC_ ),
     $                       NPCOL )
            INLQ = NUMROC( N-ILO+IOFF+1, NB, MYCOL, ILCOL, NPCOL )
            LWMIN = NB*( NB + MAX( IHIP+1, IHLP+INLQ ) )
*
            WORK( 1 ) = DBLE( LWMIN )
            LQUERY = ( LWORK.EQ.-1 )
*
            IF( IROFFA.NE.ICOFFA .OR. IROFFA.NE.0 ) THEN
               INFO = -4
            ELSE IF( DESCA( MB_ ) .NE. DESCA( NB_ ) ) THEN
               INFO = -(500+NB_)
            ELSE IF( LWORK.LT.LWMIN .AND. .NOT.LQUERY ) THEN
*
               INFO = -9
            END IF
         END IF
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL PXERBLA( CTXT, 'PDGEEV1', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         GO TO 10
      END IF
*   A    
*
      CALL PDGEHRD( N, ILO, IHI, A, IA, JA, DESCA, TAU,
     $              WORK, LWORK, INFO )
*
      IF( INFO.NE.0 ) THEN
         RETURN
      END IF
*
  10  CONTINUE
*
      HBL = DESCA( NB_ )
      LDA = DESCA( LLD_ )
      IAFIRST = DESCA( 7 )
      JAFIRST = DESCA( 8 )
      LCMRC = ILCM( NPROW, NPCOL )
*
*         
*
      LOCALK = NUMROC( N, HBL, MYCOL, JAFIRST, NPCOL )
      JJ = N / HBL
      IF( JJ*HBL.LT.N )
     $   JJ = JJ + 1
      JJ = 7*JJ / LCMRC
      LWORK1 = 3*N+MAX( 2*LDA + 2*LOCALK, JJ )
*
      IF( LQUERY ) THEN
        IF( WORK(1) .GT. DBLE( LWORK1 ) ) THEN
          RETURN
        ELSE
          WORK(1) = DBLE( LWORK1 ) 
          RETURN
        END IF
      ELSE IF( LWORK .LT. LWORK1 ) THEN
            INFO = -9
            CALL PXERBLA( CTXT, 'PDGEEV1', -INFO )
            RETURN
      END IF
*
*       
*
      CALL PDLAHQR( .FALSE., .FALSE., N, ILO, IHI, A, DESCA, WR, WI,
     $              ILOZ, IHIZ, Z , DESCA, WORK, LWORK, IWORK,
     $              ILWORK, INFO )
*
      RETURN
      END
